// cubeview.h : interface of the CCubeView class
//
// This is a part of the Microsoft Foundation Classes C++ library.
// Copyright (C) 1992-1998 Microsoft Corporation
// All rights reserved.
//
// This source code is only intended as a supplement to the
// Microsoft Foundation Classes Reference and related
// electronic documentation provided with the library.
// See these sources for detailed information regarding the
// Microsoft Foundation Classes product.

#include "gl\glaux.h"
#include "plansza.h"

class CCubeView : public CView
{
protected: // create from serialization only
	CCubeView();
	DECLARE_DYNCREATE(CCubeView)

// Attributes
public:
	CCubeDoc* GetDocument();

	unsigned int CzasBialy, CzasCzarny;
	CPalette    m_cPalette;
	CPalette    *m_pOldPalette;
	CRect       m_oldRect;
	float       m_fRadius;
	CClientDC   *m_pDC;
	GLfloat		wAngleX;
	GLfloat		wAngleY;
	GLfloat		wAngleZ;
	char		kursor_x;
	char		kursor_y;
	plansza		plan;
	signed char		kursor;

	CPoint		poprzednie_wsp;
	//do kas
	pionek cofnij[32];

	bool		Pauza;
private:
	GLfloat     fMaxObjSize, fAspect;
	GLfloat     fNearPlane, fFarPlane;

// Operations
public:
	void Init();
	void CreateRGBPalette(void);
	BOOL bSetupPixelFormat(void);
	unsigned char ComponentFromIndex(int i, UINT nbits, UINT shift);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCubeView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	//}}AFX_VIRTUAL

// Implementation
public:
	void KonfNowaGre();
	void Ruch_Komputera();
	bool podswietl[32];
	int xy2obiekt(CPoint point);
	pionek CzyjaKolej;
	UINT Styl_Pionkow;

	void DrawScene(void);
	void MakeScene(void);
	void Trafiony(int ktory);

	bool czy_wszystkie_bicia_podswietlone(int valid_nr);

	bool pierwsze_uruchomienie;

	virtual ~CCubeView();
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
//	GLuint	texture[2];
	BOOL    m_play;
	float temp;

// Generated message map functions
protected:
	bool Czy_Pauza();
	//{{AFX_MSG(CCubeView)
	afx_msg void OnFilePlay();
	afx_msg void OnUpdateFilePlay(CCmdUI* pCmdUI);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnRButtonDown( UINT nFlags, CPoint point );
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnKeyDown( UINT nChar, UINT nRepCnt, UINT nFlags );
	afx_msg void OnPauza();
	afx_msg void OnPionkiStandard();
	afx_msg void OnPionkiArtdeco();
	afx_msg void OnZasady();
	afx_msg void OnAuthors();
	afx_msg void OnHelptopics();
	afx_msg void OnHowplay();
	afx_msg void OnLicense();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

#ifndef _DEBUG  // debug version in cubeview.cpp
inline CCubeDoc* CCubeView::GetDocument()
   { return (CCubeDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
