//klasa obslugujaca szachownice
#ifndef __Szachownica__
#define __Szachownica__

struct XY
{
		int x;
		int y;
};
enum TypGracza { Czlowiek, Komputer, Siec };
struct Gracz
{
		CString Nazwa;
		TypGracza typ;
};

enum pionek { Pusty, Bialy, Czarny, BialaDamka, CzarnaDamka, Zbity };
struct pole
{
		int lp;
		pionek typ;
		pole *lewy;
		pole *prawy;
		pole *tlewy;
		pole *tprawy;
};

struct ustawionko
{
	pionek pola[32];
};

struct najlepszy
{
	int wartosc;
	int numer;
};

class plansza
{
	
public:
	Gracz KtoBialy, KtoCzarny;
	pole ustawienie[32];
	int valid_moves_count;
	ustawionko valid_moves[250];
	unsigned long int stat_ile_kombinacji;  //statystyka
	unsigned int czas_ostatniego_ruchu_komp;
	int MAX_H;
	
private:
	pole temp_ustawienie[32];
	pionek	tmp_ustawienie[32];
	
	int ile_zbitych;
	int max_zbitych;

public:
	void Testuj_Szybkosc_Komputera(int jakie_h);
	bool sprawdz_kierunek_damki(enum pionek ktorych, char kierunek, int nr);
	pole* wskaz(char kierunek, pole* ptr);
	enum pionek czyja_damka(enum pionek ktorych);
	bool sprawdz_bicie_damki(enum pionek ktorych, int nr);
	void sprawdz_plansze(bool czy_plansza_odwrocona);
	enum pionek czyja_figura(enum pionek figura);
	void zeruj_plansze(void);
	najlepszy evaluate(char h, pionek CzyjRuch);
	najlepszy bestmove(char h, int alfa, int beta,  pionek CzyjRuch);
	void Ruch_Komputera(pionek CzyjRuch);
	void odwroc(void);
	enum pionek przeciwny(enum pionek czemu);
	bool sprawdz_kierunek(enum pionek ktorych, int nr1, int nr2, int nr3);
	void dopisz_ruch(enum pionek ktorych);
	bool sprawdz_bicie(enum pionek ktorych, int nr);
	void odtworz();
	void zapamietaj();
	void get_possible_moves(pionek ktorych);
	plansza(int PoczatkoweH=10);
	~plansza();
	void Przesun(int skad, int dokad);
	int XYtoI(int x, int y);
	XY ItoXY(int i);
};




#endif